//
//  AASFileManagerOperations.h
//  AASFilesystemTools
//
//  Created by Andreas Schwarz on 3/3/08.
//  Feel free to do what you like with this code, but if you improve upon it
//  please share :-).
//
//  OS X 10.5 or later required.

#import <Foundation/Foundation.h>
#import <CoreServices/CoreServices.h>


/* This AASFileManager category contains some convenient methods for getting file objects as well as methods to manipulate files associated with file objects. Soon these will return an NSDictionary with error information rather than just a BOOL value. */




@interface AASFileManager (FileOperations)


/* Convenience methods */

/* Method for getting an autoreleased array of file objects that represent the contents of a directory if you don't want to subscribe to it. If there's another object that has subscribed to the directory, this will be able to efficiently reuse its collection. */
- (NSArray *)filesInDirectory:(AASFile *)directory;



/* File Manipulation */

/* Takes an array of file objects and moves them to the trash by sending appleevents to the Finder */
- (BOOL)moveFilesToTrash:(NSArray *)files;



@end
