//
//  GBNewPrefsWindowController.h
//  gBrowser
//
//  Created by Andreas Schwarz on Mon Mar 11 2002.
//  Copyright (c) 2001 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>

@class GBPrefsOVDataSource;
@class GBPrefsTabController;
@class GBPrefsData;
@class GBAppPrefsData;
@class GBPrefsInfoTabController;

@interface GBNewPrefsWindowController : NSWindowController {
    IBOutlet NSOutlineView *prefsOutlineView;
    IBOutlet NSTextField *currentSelection;
    IBOutlet NSTabView *tabView;
    IBOutlet NSButton *revertToDefaultButton;
    IBOutlet NSButton *revertToAppButton;
    IBOutlet NSBox *bottomLine;
    IBOutlet NSButton *appPrefsSaveButton;
    IBOutlet NSButton *appPrefsApplyButton;
    IBOutlet NSButton *appPrefsRevertButton;
    
    GBPrefsInfoTabController *fileFilterMainTC;
    GBPrefsInfoTabController *launchMainTC;
    GBPrefsInfoTabController *previewPaneMainTC;
    GBPrefsInfoTabController *fileListMainTC;
    GBPrefsInfoTabController *imagesMainTC;
    GBPrefsInfoTabController *slideshowMainTC;
    GBPrefsInfoTabController *imageViewerMainTC;
    GBPrefsInfoTabController *hotKeysMainTC;
    GBPrefsInfoTabController *menusMainTC;
    
    NSMutableArray *controllers;
    GBPrefsTabController *currentController;
    
    NSRect standardRevertToAppButtonFrame;
    NSRect hiddenRevertToAppButtonFrame;
    NSRect standardRevertToDefaultButtonFrame;
    NSRect hiddenRevertToDefaultButtonFrame;
    
    BOOL appPrefs;
    
    BOOL loaded;
    
    id gBrowserDocument;
    
    GBPrefsData *prefsData;
    id delegate;
    BOOL changeDone;
}

- (id)initWithPrefs:(GBPrefsData *)prefs delegate:(id)del controllers:(NSArray *)cont;
- (id)initAsAppPrefs:(BOOL)app withPrefs:(GBPrefsData *)prefs delegate:(id)del controllers:(NSArray *)cont;

- (id)getAppPrefsData;
- (id)getPrefsData;

- (void)saveSheetDidEnd:(NSWindow *)sheet returnCode:(int)returnCode contextInfo:(void *)contextInfo;


- (void)registerNotificationObservers;

- (void)updateForNewController;

- (BOOL)isAppPrefs;

- (Class)prefsClassForController:(GBPrefsTabController *)c;

- (id)delegate;

- (void)updateWindow;

- (void)setTabViewToTab:(NSTabViewItem *)tab;

- (void)selectFileListTab;
- (void)selectPreviewsBasicTab;
- (void)selectOpenWithTab;
- (void)selectMoveToTab;
- (void)selectFileListAppearanceTab;

- (void)displaySaveDefaultPrefsError;

- (void)selectItemWithTag:(int)tag underParent:(int)parentTag;

- (void)checkSaveAndRevertButtonStatus:(NSNotification *)notification;
- (void)changeWasMade:(NSNotification *)notification;
- (void)updatePrefsWindowFrame:(NSNotification *)notification;
- (void)presentSaveSheet;
- (BOOL)changeDone;

- (IBAction)revertToDefaultButtonAction:(id)sender;
- (IBAction)revertToAppButtonAction:(id)sender;
- (IBAction)savePrefs:(id)sender;
- (IBAction)revertPrefs:(id)sender;
- (IBAction)applyPrefs:(id)sender;


@end

@interface NSObject (GBPrefsWindowControllerDelegate)
- (void)defaultPrefsClosed;
- (void)defaultPrefsSheetGone:(BOOL)gone;
@end

@interface NSObject (GBPrefsBundlePrincipalClassProtocol)
- (NSArray *)controllers;
@end

extern NSString *GBDefaultPrefsChangedNotification;


