//
//  GBPrefsTabController.h
//  gBrowser
//
//  Created by Andreas Schwarz on Wed Mar 13 2002.
//  Copyright (c) 2001 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>

@class GBPrefsData;
@class GBAppPrefsData;

@interface GBPrefsTabController : NSObject {
    IBOutlet NSTabViewItem *tabViewItem;
    IBOutlet id parent;
    
    id prefsDelegate;
}

- (void)setPrefsDelegate:(id)del;

// Revert button functions
- (BOOL)showsRevertButton;

// To do any initial setup needed
- (void)performSetup:(id)prefsDel;

// To do any final cleanup needed
- (void)performShutDown;

// updating the info
- (void)update;

- (NSTabViewItem *)tab;

- (int)tag;

- (BOOL)hasChildren;

- (GBPrefsTabController *)tcParent;

- (BOOL)isAppwide;

// Handling revert button presses
- (void)doRevertToDefaultButtonAction:(id)sender;
- (void)doRevertToAppButtonAction:(id)sender;
- (void)confirmRevertToDefault;
- (void)confirmRevertToApp;
- (void)revertSheetDidEnd:(NSWindow *)sheet returnCode:(int)returnCode contextInfo:(void  *)contextInfo;
- (void)doRevertToDefault;
- (void)doRevertToApp;

// Returns type of prefs this is as string
- (NSString *)type;

// Registering notification observers
- (void)registerNotificationObservers;

// Handling font manager
- (void)changeFont:(id)sender;

@end


// Prefs delegate must implement these methods
@interface NSObject (GBPrefsDelegate)
- (id)getPrefsData;
- (id)getAppPrefsData;
- (BOOL)isAppPrefs;
- (Class)prefsClassForController:(GBPrefsTabController *)c;
@end


